#include "Xarch.h"
#include "xaa.h"
#include "xf86.h"
#include "xf86_OSproc.h"
#include "xf86_ansic.h"
#include "xf86Pci.h"
#include "xf86PciInfo.h"
#include "xf86Xinput.h"
#include "xf86fbman.h"
#include "xf86i2c.h"
#include "xf86xv.h"
#include "Xv.h"
#include "xf86Cursor.h"
#include "regionstr.h"
#include "xaalocal.h"

#include "r128.h"
#include "r128_reg.h"
#include "r128_video.h"
#include "r128_i2c.h"
#include "msp3430.h"
#include "theatre.h"

void EnableMSP3430 (PortPrivPtr pPPriv)
{
int count;
CARD8 high,low;
AdaptorPrivPtr pAPriv=pPPriv->pAdaptor;
ScrnInfoPtr pScrn=pAPriv->pScrn;
CARD16 t,result;

 /*      if(I2CProbeAddress(pPPriv,MSP3430)){ */
   if(pPPriv->theatre_num>=0){
     	pPPriv->msp3430_addr=MSP3430;
     	xf86DrvMsg(pScrn->scrnIndex,X_INFO,"Found MSP3430 audio processor\n");
     	} else {
	pPPriv->msp3430_addr=0;
	}

    /* Reset the MSP3430 */
    SetMSP3430Control (pPPriv, 0x00, 0x80, 0x00);
    /* Set it back to normal operation */
    SetMSP3430Control (pPPriv, 0x00, 0x00, 0x00);

    /* Set MODUS register for: */
    /* bit 0 - automatic sound selection */
    /* bit 1 - enable STATUS change */
    /* bit 12 - detect 6.5 Mhz carrier as D/K1, D/K2 or D/K NICAM !!! Seems not to work !! */
    /* bit 13 - detect 4.5 MHz carrier as BTSC */
    if( ( pPPriv->wStandard & 0x00ff ) == DEC_PAL ) {    
    	SetMSP3430Data (pPPriv, WR_DEM, 0x00, 0x30, 0x30, 0x03);    
    	} else {    
    	SetMSP3430Data (pPPriv, WR_DEM, 0x00, 0x30, 0x20, 0x03);
    	}
    
    if((pPPriv->wStandard & 0x00ff)==DEC_PAL){
		/* PAL setting */
		SetMSP3430Data(pPPriv,WR_DEM,0x20,0x00,0x01);
		} else {
	    	/* Set STANDARD SELECTION register to M-BTSC-Stereo */
		SetMSP3430Data (pPPriv, WR_DEM, 0x00, 0x20, 0x00, 0x20);
		}

    /* Write to DSP, register 0x0008, (loudspeaker channel source/matrix) */
    /* This sets the source to the TV tuner, for stereo operation */
    switch(pPPriv->wConnector){
    	case DEC_TUNER:
    		SetMSP3430Data (pPPriv, WR_DSP, 0x00, 0x08, 0x03, 0x20);   	
		break;
	case DEC_SVIDEO:
		/* this has not been checked yet.. could be bogus */
    		/* SCART Input Prescale: 0 dB gain */
		SetMSP3430Data (pPPriv, WR_DSP, 0x00, 0x0d, 0x19, 0x00);
    		SetMSP3430Data (pPPriv, WR_DSP, 0x00, 0x08, 0x02, 0x20);   	
		break;
	case DEC_COMPOSITE:
	default:
    		/* SCART Input Prescale: 0 dB gain */
		SetMSP3430Data (pPPriv, WR_DSP, 0x00, 0x0d, 0x19, 0x00);
		
    		SetMSP3430Data (pPPriv, WR_DSP, 0x00, 0x08, 0x02, 0x20);
    		break;
	}

    if ( ( pPPriv->wStandard & 0x00ff ) == DEC_PAL ) {
    
     SetMSP3430Data (pPPriv, WR_DSP, 0x00, 0x0e, 0x24, 0x03);
     SetMSP3430Data (pPPriv, WR_DSP, 0x00, 0x10, 0x00, 0x5a);
     switch( pPPriv->wStandard & 0xff00 ) {
     
     	case extPAL_AUTO:	/* autodetect standard selection */
     	
    		SetMSP3430Data (pPPriv, WR_DEM, 0x00, 0x20, 0x00, 0x01);
        		count = 30; /* time shouldn't exceed 1s, just in case */
	    	do {
     			usleep(100000);
     			GetMSP3430Data (pPPriv, RD_DEM, 0x00, 0x7e, &high, &low);
	     		result = ( high << 8 ) | low;
     			--count;
	    	} while( result > 0x07ff && count > 0 );
	    	
		/* SECAM is always selected instead of PAL D/K ;( !!! CHECK THIS !!! */
		if( result == 0x09 ) {
			fprintf( stderr, "PAL D/K detection failed !!!\n" );
			/* force PAL D/K  */
			SetMSP3430Data (pPPriv, WR_DEM, 0x00, 0x20, 0x00, 0x04);
		}
		
		break;
		
	case extPAL_DK1:
	
		 SetMSP3430Data (pPPriv, WR_DEM, 0x00, 0x20, 0x00, 0x04);
		 
		 break;
		 
	case extPAL:
	default:
	
                 SetMSP3430Data (pPPriv, WR_DEM, 0x00, 0x20, 0x00, 0x03);
                 
                 break;
                 	
     	}

     	SetMSP3430Data (pPPriv, WR_DSP, 0x00, 0x00, 0x73, 0x00);
    } else {
    /* Write to DSP, register 0x000E, (prescale FM/FM matrix) */
    SetMSP3430Data (pPPriv, WR_DSP, 0x00, 0x0e, 0x24, 0x03);

    /* Set volume to 0 db. */
    SetMSP3430Data (pPPriv, WR_DSP, 0x00, 0x00, 0x73, 0x00);

    }
    return;

} /* EnableMSP3430 ()... */


void DisableMSP3430 (PortPrivPtr pPPriv)
{
    ResetMSP3430 (pPPriv);
    SetMSP3430Data (pPPriv, 0x12, 0x00, 0x00, 0xFF, 0x00);
}


void SetMSP3430Data (PortPrivPtr pPPriv, CARD8 RegAddress, CARD8 RegSubAddressHigh, CARD8 RegSubAddressLow,
                     CARD8 RegValueHigh, CARD8 RegValueLow)
{
    CARD8  retval, data[16], counter;
    I2C_PACKET Packet;

    /* set data */
    data[0] = RegAddress;
    data[1] = RegSubAddressHigh;
    data[2] = RegSubAddressLow;
    data[3] = RegValueHigh;
    data[4] = RegValueLow;
    Packet.data = data;
    Packet.start = 1;
    Packet.stop = 1;
    Packet.number_of_bytes = 5;
    Packet.address = MSP3430;
    counter = 0;

    do
    {
        retval=I2C_Set (pPPriv, &Packet);
        counter++;
    }
    while ((counter < 5) && (retval != I2C_DONE));

    return;

} /* SetMSP3430Data ()... */


void SetMSP3430Control (PortPrivPtr pPPriv, CARD8 RegAddress, CARD8 RegValueHigh, CARD8 RegValueLow)
{
    CARD8  retval, data[16];
    CARD8 counter = 0;
    I2C_PACKET Packet;

    /* set data */
    data[0] = RegAddress;
    data[1] = RegValueHigh;
    data[2] = RegValueLow;
    Packet.data = data;
    Packet.start = 1;
    Packet.stop = 1;
    Packet.number_of_bytes = 3;
    Packet.address = MSP3430;

    do
    {
        retval = I2C_Set (pPPriv, &Packet);
        counter += 1;
    }
    while ((counter < 5) && (retval != I2C_DONE));

    return;

} /* SetMSP3430Control ()... */


void GetMSP3430Data (PortPrivPtr pPPriv, CARD8 RegAddress, CARD8 RegSubAddressHigh, CARD8 RegSubAddressLow,
                 CARD8 *RegValueHigh, CARD8 *RegValueLow)
{
    CARD8  retval, data[16];
    CARD8 counter = 0;
    I2C_PACKET Packet;

    /* set data */
    data[0] = RegAddress;
    data[1] = RegSubAddressHigh;
    data[2] = RegSubAddressLow;

    Packet.data = data;
    Packet.start = 1;
    /* NO STOP BIT!! The 3430 does not want a stop bit during this particular */
    /* transfer.  See the spec. */
    Packet.stop = 0;
    Packet.number_of_bytes = 3;
    Packet.address = MSP3430;

    do
    {
        retval = I2C_Set (pPPriv, &Packet);
        counter += 1;
    }
    while ((counter < 5) && (retval != I2C_DONE));

    /* set data */
    Packet.address = MSP3430 | 0x1;
    Packet.number_of_bytes = 2;
    Packet.start = 1;
    Packet.stop = 1;
    do
    {
        retval = I2C_Get (pPPriv, &Packet);
        counter += 1;
    }
    while ((counter < 5) && (retval != I2C_DONE));

    *RegValueHigh = data[0];
    *RegValueLow = data[1];

    return;
}  /* GetMSP3430Data ()... */


CARD16 ReadI2CWord (PortPrivPtr pPPriv, CARD16 Register, CARD16 SubAddr)
{
    CARD8 RegValueHi, RegValueLo;
    CARD16 retval = 0;

    GetMSP3430Data (pPPriv, Register, (CARD8)((SubAddr >> 8) & 0x00FF), (CARD8)(SubAddr & 0x00FF),
                    &RegValueHi, &RegValueLo);

    retval = (RegValueHi << 8) | (RegValueLo & 0xFFFF);

    return (retval);

} /* ReadI2CWord ()... */


void WriteI2CWord (PortPrivPtr pPPriv, CARD16 Register, CARD16 SubAddr, CARD16 Data)
{

    SetMSP3430Data (pPPriv, Register, (CARD8)((SubAddr >> 8) & 0x00FF), (CARD8)(SubAddr & 0xFF00),
                    ((Data >> 8) & 0x00FF), (Data & 0x00FF));

    return;

} /* WriteI2CWord ()... */


void ResetMSP3430 (PortPrivPtr pPPriv)
{
    /* Reset the MSP3430 */
    SetMSP3430Control (pPPriv, 0x00, 0x80, 0x00);
    /* Set it back to normal operation */
    SetMSP3430Control (pPPriv, 0x00, 0x00, 0x00);
}

void MSP3430_SetVolume (PortPrivPtr pPPriv, CARD8 value)
{
    CARD16 result;

    result = ReadI2CWord (pPPriv, RD_DSP, 0x0000);
    result &= 0x00FF; /* clear volume bits. */

    WriteI2CWord (pPPriv, WR_DSP, 0x0000, ((value << 8) | result) );
    WriteI2CWord (pPPriv, WR_DSP, 0x0007, ((value << 8) | result) );
}

void MSP3430_SetSource(PortPrivPtr pPPriv, CARD8 value)
{
    /* Write to DSP, register 0x0008, (loudspeaker channel source/matrix) */
    /* This sets the source to the TV tuner, for stereo operation */
    SetMSP3430Data (pPPriv, WR_DSP, 0x00, 0x08, value, 0x20);
}
