#ifndef __I2C_H__
#define __I2C_H__

#define I2C_DONE	(1<<0)
#define I2C_NACK	(1<<1)
#define I2C_HALT	(1<<2)
#define I2C_SOFT_RST	(1<<5)
#define I2C_DRIVE_EN	(1<<6)
#define I2C_DRIVE_SEL	(1<<7)
#define I2C_START	(1<<8)
#define I2C_STOP	(1<<9)
#define I2C_RECEIVE	(1<<10)
#define I2C_ABORT	(1<<11)
#define I2C_GO		(1<<12)
#define I2C_SEL		(1<<16)
#define I2C_EN		(1<<17)


#define R128_CLOCK_FREQ   (80000.0)

#include "r128_video.h"

typedef struct {
	CARD8 number_of_bytes;
	CARD8 address;
	CARD8 *data;
	CARD8 start;
	CARD8 stop;
	} I2C_PACKET;	


void R128_I2CInit(PortPrivPtr pPPriv);
void R128_WaitForFifo (PortPrivPtr pPPriv, CARD32 entries);
CARD8 I2C_WaitForAck (PortPrivPtr pPPriv);
CARD8 I2C_Set (PortPrivPtr pPPriv, I2C_PACKET *Packet);
CARD8 I2C_Get (PortPrivPtr pPPriv, I2C_PACKET *Packet);
Bool I2CProbeAddress(PortPrivPtr pPPriv, CARD8 addr);


#endif
